Attribute VB_Name = "modINI"
Option Explicit

'--------for INI file read/write
Private Declare Function GetPrivateProfileSection Lib "kernel32" Alias "GetPrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileSection Lib "kernel32" Alias "WritePrivateProfileSectionA" (ByVal lpAppName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
'-------------------

Public ini_CI As String
Public ini_BG As String
Public ini_CD As String
Public ini_CT As String
Public ini_AA As String
Public ini_FR As String
Public ini_ST As String
'----------------------------

'reads ini string
Public Function ReadIni(FileName As String, Section As String, Key As String) As String
Dim RetVal As String * 1000, V As Long
V = GetPrivateProfileString(Section, Key, "", RetVal, 1000, FileName)
ReadIni = Left(RetVal, V)
End Function
 
'reads ini section
Public Function ReadIniSection(FileName As String, Section As String) As String
Dim RetVal As String * 1000, V As Long
V = GetPrivateProfileSection(Section, RetVal, 1000, FileName)
ReadIniSection = Left(RetVal, V - 1)
End Function
 
'writes ini
Public Sub WriteIni(FileName As String, Section As String, Key As String, Value As String)
WritePrivateProfileString Section, Key, Value, FileName
End Sub
 
'writes ini section
Public Sub WriteIniSection(FileName As String, Section As String, Value As String)
WritePrivateProfileSection Section, Value, FileName
End Sub

'sub to delete a particular key inside an ini section.
Public Sub DeleteIniKey(ByVal strSection As String, ByVal strKeyname As String, ByVal strfullpath As String)
Call WritePrivateProfileString(strSection, strKeyname, 0&, strfullpath)
End Sub

'sub to delete an entire ini section.
Public Sub DeleteIniSection(ByVal strSection As String, ByVal strfullpath As String)
Call WritePrivateProfileString(strSection, 0&, 0&, strfullpath)
End Sub
