Attribute VB_Name = "modTitleBar"
   
Option Explicit
   
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'Private Const GWL_STYLE = (-16)
Private Const WS_CAPTION = &HC00000
Private Const WS_MAXIMIZEBOX = &H10000
Private Const WS_MINIMIZEBOX = &H20000
Private Const WS_SYSMENU = &H80000

'API Calls Used To Remove The Title Bar From Window
'(Make A Sizeable Borderless Form)
'Public Const GWL_STYLE = (-16)
'Public Const GWL_EXSTYLE = (-20)
Public Const WS_DLGFRAME = &H400000
'Requires Windows 2000 or later:
Public Const WS_EX_LAYERED = &H80000
Public Const WS_EX_TRANSPARENT = &H20&
Public Const LWA_COLORKEY = &H1
Public Const LWA_ALPHA = &H2
Public Const BM_SETSTATE = &HF3

'window position constants
Private Const SWP_SHOWWINDOW = &H40
Private Const SWP_HIDEWINDOW = &H80
Private Const SWP_FRAMECHANGED = &H20
Private Const SWP_NOACTIVATE = &H10
Private Const SWP_NOCOPYBITS = &H100
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOOWNERZORDER = &H200
Private Const SWP_NOREDRAW = &H8
Private Const SWP_NOREPOSITION = SWP_NOOWNERZORDER
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_DRAWFRAME = SWP_FRAMECHANGED
Private Const HWND_NOTOPMOST = -2

'API declarations
Private Declare Function GetWindowRect Lib "user32" (ByVal hWnd As Long, lpRect As RECT) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long

Public Declare Function SetLayeredWindowAttributes Lib "user32" _
    (ByVal hWnd As Long, ByVal crKey As Long, _
    ByVal bAlpha As Byte, ByVal dwFlags As Long) As Long

Public Function ShowTitleBar(ByVal frm As Form, ByVal bState As Boolean)
    On Error Resume Next
    Dim lstyle As Long
    Dim tR As RECT
    'get the window's position
    Call GetWindowRect(frm.hWnd, tR)
    'should the titlebar style be not visible?
    lstyle = GetWindowLong(frm.hWnd, GWL_STYLE)
    If (bState) Then
       'set the style's for the current window (if titlebar active)
        frm.Caption = frm.Tag
        If frm.ControlBox Then lstyle = lstyle Or WS_SYSMENU
        If frm.MaxButton Then lstyle = lstyle Or WS_MAXIMIZEBOX
        If frm.MinButton Then lstyle = lstyle Or WS_MINIMIZEBOX
        If frm.Caption <> "" Then lstyle = lstyle Or WS_CAPTION
    Else
       'titlebar is invisible
        'set the current caption to the forms tag
        frm.Tag = frm.Caption
        'remove the caption (otherwise the titlebar will not hide)
        frm.Caption = vbNullString
        lstyle = lstyle And Not WS_SYSMENU
        lstyle = lstyle And Not WS_MAXIMIZEBOX
        lstyle = lstyle And Not WS_MINIMIZEBOX
        lstyle = lstyle And Not WS_CAPTION
    End If
    '
    Call SetWindowLong(frm.hWnd, GWL_STYLE, lstyle)
    'change the window style maintaining current sizes
    Call SetWindowPos(frm.hWnd, 0, tR.Left, tR.Top, tR.Right - tR.Left, tR.Bottom - tR.Top, SWP_NOREPOSITION Or SWP_NOZORDER Or SWP_FRAMECHANGED)
    frm.Refresh
    'fire resize code
    'Call Form_Resize
End Function


